10MODE5:VDU5        - set screen mode 5 (160x256x4 colours), VDU5 tells it to use the graphics cursor position instead of text cursor position when PRINTing
15S%=0              - set score S%, % indicates an integer variable
16L%=3              - set lives L%
20 VDU 29,640;512;  - set the origin of the graphics coordinate system to be the middle of the screen (all coordinates are 1280x1024 on bbc regardless of actual resolution)
21TIME=0:es%=0      - TIME is a built in variable that counts up in hundredths of a second, es% is the enemy speed incrememt which increases over time
30 PROCcircle(350,0)     \
40 PROCcircle(400,0)      \
50 PROCcircle(50,0)        \
60MOVE0,350:DRAW 0,50      /   draw the game area
70MOVE0,-350: DRAW 0,-50  /
80MOVE-350,0:DRAW -50,0  /
90MOVE 350,0:DRAW 50,0  /
92PROCnewenemy      - create a new enemy travelling at a random angle
93PROCprintscore:PROCprintlives - print the score and lives 
95D%=0              - set the current player position at 0 degrees
97PROCdrawenemy:PROCdrawplayer    - draw the enemy and player at their initial positions

100REPEAT                         - main loop
110IF TIME>500 THEN TIME=0:es%=es%+1  - if time >500 then reset time and increase enemy speed slightly
139A%=0
140IF INKEY(-98) A%=A%+20   - check z key directly ignoring keyboard buffer and update angle
150IF INKEY(-67) A%=A%-20   - check x key directly ignoring keyboard buffer and update angle
151PROCmoveplayer(A%)       - move the player according to the angle set above
155PROCdrawenemy            - undraw the enemy
157PROCmoveenemy            - move the enemy
158PROCdrawenemy            - draw the enemy at the new position
159A$=INKEY$(10)            - just added this for a delay (wait for a keypress for 10 hundredths of a second)
160UNTIL L%=0               - repeat until lives=0

170MOVE -280,0              - move graphics cursor
180GCOL0,1                  - set graphics draw mode as normal and colour 1
190PRINT "GAME OVER"
200GCOL0,2                  - set graphics draw mode as normal and colour 2
210MOVE -270,0              - slightly offset from the previous one
220PRINT "GAME OVER"
230GCOL 0,3                 - set graphics draw mode as normal and colour 3
240MOVE-350,-30
250PRINT "PRESS SPACE"
260REPEATUNTILGET=32        - repeat until space is pressed (space = ascii 32)
270GOTO10                   - restart

1000DEF PROCcircle(X,Y)     - routine to draw a circle at x,y using minsky circle algorithm
1010FORI%=0 TO 400
1020PLOT69,X,Y              - plot a pixel, note: x and y are floating point variables
1030X=X-Y/64
1040Y=Y+X/64
1050NEXT
1060ENDPROC

2000DEF PROCdrawplayer
2005GCOL3,1                 - set draw mode to 3-EOR (means we can undraw by drawing the item again at the same position) and colour 1
2006X%=COS(RAD(D%))*375     - calculate player x and y position
2007Y%=SIN(RAD(D%))*375
2010MOVE X%-24,Y%+12        - move graphics cursor (-24 and +12 are because the xy position calculated is for the centre of the player)
2020PRINT"0"                - print player '0' character
2030ENDPROC

3000DEF PROCmoveenemy
3010R%=R%+20+es%            - increase radius of enemy player
3020IF R%>=375 PROCcheckcollision  - if we hit the outer rim check for collisions
3025ex%=COS(RAD(ed%))*R%  - calculate x and y position of enemy
3030ey%=SIN(RAD(ed%))*R%
3050ENDPROC

4000DEFPROCdrawenemy
4010GCOL3,2                 - set draw mode to 3-EOR (means we can undraw by drawing the item again at the same position) and colour 2
4030MOVE ex%-24,ey%+12      - move to enemy xy position (offsets as above)
4040PRINT"#"                - print enemy '#'
4050ENDPROC

5000DEFPROCnewenemy
5010R%=0                    - set enemy back to the centre
5015ed%=RND(18)*20          - set random enemy direction in 0-360 degress in steps of 20 degrees
5020ex%=0:ey%=0             - set enemy x and y posiiton to 0
5025ENDPROC

6000DEFPROCprintscore
6005GCOL3,3                 - set draw mode to 3-EOR (means we can undraw by drawing the item again at the same position) and colour 3
6010MOVE-640,480            - move graphics cursor to top left
6020PRINT "Score:";S%       - print current score
6030ENDPROC

7000DEFPROCcheckcollision
7010IF ABS(ed%-D%)<10 PROChit ELSE PROCmiss  - if the enemy angle and the player angle are within 10 degrees of each other then we collided else we missed
7020PROCnewenemy           - create a new enemy in the centre
7030ENDPROC

8000DEFPROChit
8005PROCprintscore         - unprint the score
8010S%=S%+100              - increase the score
8020PROCprintscore         - print the score
8038ENDPROC

9000DEFPROCmoveplayer(v%)
9010PROCdrawplayer         - undraw the player character
9020D%=D%+v%               - move the current player angle according to the value passed in
9030IF D%>360 D%=D%-360    - cater for if we go past 360 degress
9040IF D%<0 D%=D%+360      - or if we go less than 0 degrees
9050PROCdrawplayer         - draw the player character at the new position
9060ENDPROC

9500DEFPROCprintlives
9510GCOL3,3                 - set draw mode to 3-EOR (means we can undraw by drawing the item again at the same position) and colour 3
9520MOVE180,480             - move to top right
9530PRINT "Lives:";L%       - print current lives
9540ENDPROC

9600DEFPROCmiss
9610PROCprintlives          - unprint the lives
9620L%=L%-1                 - decrease the lives counter
9630PROCprintlives          - print the new lives
9640ENDPROC
